/*
**
** This file is part of the BHack Beacon.
**
** Author(s):
**  - Ian Firns <firnsy@gmail.com>
**
** BHack Beacon is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation, either version 3 of the License, or
** (at your option) any later version.
**
** BHack Beacon is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with BHack Beacon.  If not, see <http://www.gnu.org/licenses/>.
**
*/

#define MELODIES_MAX 3

const uint32_t *melodyActive = NULL;
int16_t melodyLoop = 0;
uint32_t melodyLength = 0;
uint32_t melodyIndex = 0;
uint32_t melodyTimeBase = 0;
uint32_t melodyTimeRef = 0;

const uint16_t PROGMEM midiNotes[] = {
  0x0008, 0x0008, 0x0009, 0x0009, 0x000a, 0x000a, 0x000b, 0x000c,
  0x000c, 0x000d, 0x000e, 0x000f, 0x0010, 0x0011, 0x0012, 0x0013,
  0x0014, 0x0015, 0x0017, 0x0018, 0x0019, 0x001b, 0x001d, 0x001e,
  0x0020, 0x0022, 0x0024, 0x0026, 0x0029, 0x002b, 0x002e, 0x0031,
  0x0033, 0x0037, 0x003a, 0x003d, 0x0041, 0x0045, 0x0049, 0x004d,
  0x0052, 0x0057, 0x005c, 0x0062, 0x0067, 0x006e, 0x0074, 0x007b,
  0x0082, 0x008a, 0x0092, 0x009b, 0x00a4, 0x00ae, 0x00b9, 0x00c4,
  0x00cf, 0x00dc, 0x00e9, 0x00f6, 0x0105, 0x0115, 0x0125, 0x0137,
  0x0149, 0x015d, 0x0171, 0x0188, 0x019f, 0x01b8, 0x01d2, 0x01ed,
  0x020b, 0x022a, 0x024b, 0x026e, 0x0293, 0x02ba, 0x02e3, 0x030f,
  0x033e, 0x0370, 0x03a4, 0x03db, 0x0416, 0x0454, 0x0496, 0x04dc,
  0x0526, 0x0574, 0x05c7, 0x061f, 0x067d, 0x06e0, 0x0748, 0x07b7,
  0x082d, 0x08a9, 0x092d, 0x09b9, 0x0a4d, 0x0ae9, 0x0b8f, 0x0c3f,
  0x0cfa, 0x0dc0, 0x0e91, 0x0f6f, 0x105a, 0x1152, 0x125a, 0x1372,
  0x149a, 0x15d3, 0x171f, 0x187f, 0x19f4, 0x1b80, 0x1d22, 0x1ede,
  0x20b4, 0x22a5, 0x24b5, 0x26e4, 0x2934, 0x2ba7, 0x2e3f, 0x30ff
};

const uint32_t PROGMEM sndCanonInDData[] = {
  0x00000038, // frame length = 56
  0x00000000, 0x5d0000fa, 0x00000145, 0x5a00007d, 0x000001e7, 0x5b00007d, 0x00000289, 0x5d0000fa,
  0x000003ce, 0x5a00007d, 0x00000470, 0x5b00007d, 0x00000512, 0x5d00007d, 0x000005b4, 0x5100007d,
  0x00000656, 0x5300007d, 0x000006f8, 0x5500007d, 0x0000079a, 0x5600007d, 0x0000083c, 0x5800007d,
  0x000008de, 0x5a00007d, 0x00000980, 0x5b00007d, 0x00000a22, 0x5a0000fa, 0x00000b67, 0x5600007d,
  0x00000c09, 0x5800007d, 0x00000cab, 0x5a0000fa, 0x00000df0, 0x4e00007d, 0x00000e92, 0x4f00007d,
  0x00000f34, 0x5100007d, 0x00000fd6, 0x5300007d, 0x00001078, 0x5100007d, 0x0000111a, 0x4f00007d,
  0x000011bc, 0x5100007d, 0x0000125e, 0x4e00007d, 0x00001300, 0x4f00007d, 0x000013a2, 0x5100007d,
  0x00001444, 0x4f0000fa, 0x00001589, 0x5300007d, 0x0000162b, 0x5100007d, 0x000016cd, 0x4f0000fa,
  0x00001812, 0x4e00007d, 0x000018b4, 0x4c00007d, 0x00001956, 0x4e00007d, 0x000019f8, 0x4c00007d,
  0x00001a9a, 0x4a00007d, 0x00001b3c, 0x4c00007d, 0x00001bde, 0x4e00007d, 0x00001c80, 0x4f00007d,
  0x00001d22, 0x5100007d, 0x00001dc4, 0x5300007d, 0x00001e66, 0x4f0000fa, 0x00001fab, 0x5300007d,
  0x0000204d, 0x5100007d, 0x000020ef, 0x530000fa, 0x00002234, 0x5500007d, 0x000022d6, 0x5600007d,
  0x00002378, 0x5100007d, 0x0000241a, 0x5300007d, 0x000024bc, 0x5500007d, 0x0000255e, 0x5600007d,
  0x00002600, 0x5800007d, 0x000026a2, 0x5a00007d, 0x00002744, 0x5b00007d, 0x000027e6, 0x5d00007d
};

const uint32_t PROGMEM sndJingleBellsData[] = {
  0x000000c6, // frame length = 198
  0x00000000, 0x3e0000c0, 0x000000e6, 0x470000c0, 0x000001cc, 0x450000c0, 0x000002b3, 0x430000c0,
  0x00000399, 0x3e000240, 0x0000064c, 0x3e000060, 0x000006c0, 0x3e000060, 0x00000733, 0x3e0000c0,
  0x00000819, 0x470000c0, 0x00000900, 0x450000c0, 0x000009e6, 0x430000c0, 0x00000acc, 0x40000300,
  0x00000e66, 0x400000c0, 0x00000f4c, 0x480000c0, 0x00001033, 0x470000c0, 0x00001119, 0x450000c0,
  0x00001200, 0x42000300, 0x00001599, 0x4a0000c0, 0x00001680, 0x4a0000c0, 0x00001766, 0x480000c0,
  0x0000184c, 0x450000c0, 0x00001933, 0x47000300, 0x00001ccc, 0x3e0000c0, 0x00001db3, 0x470000c0,
  0x00001e99, 0x450000c0, 0x00001f80, 0x430000c0, 0x00002066, 0x3e000300, 0x00002400, 0x3e0000c0,
  0x000024e6, 0x470000c0, 0x000025cc, 0x450000c0, 0x000026b3, 0x430000c0, 0x00002799, 0x40000240,
  0x00002a4c, 0x400000c0, 0x00002b33, 0x400000c0, 0x00002c19, 0x480000c0, 0x00002d00, 0x470000c0,
  0x00002de6, 0x450000c0, 0x00002ecc, 0x4a0000c0, 0x00002fb3, 0x4a0000c0, 0x00003099, 0x4a0000c0,
  0x00003180, 0x4a0000c0, 0x00003266, 0x4c0000c0, 0x0000334c, 0x4a0000c0, 0x00003433, 0x480000c0,
  0x00003519, 0x450000c0, 0x00003600, 0x43000240, 0x00003999, 0x470000c0, 0x00003a80, 0x470000c0,
  0x00003b66, 0x47000180, 0x00003d33, 0x470000c0, 0x00003e19, 0x470000c0, 0x00003f00, 0x47000180,
  0x000040cc, 0x470000c0, 0x000041b3, 0x4a0000c0, 0x00004299, 0x43000120, 0x000043f3, 0x45000060,
  0x00004466, 0x47000300, 0x00004800, 0x480000c0, 0x000048e6, 0x480000c0, 0x000049cc, 0x48000120,
  0x00004b26, 0x48000060, 0x00004b99, 0x480000c0, 0x00004c80, 0x470000c0, 0x00004d66, 0x470000c0,
  0x00004e4c, 0x47000060, 0x00004ec0, 0x47000060, 0x00004f33, 0x470000c0, 0x00005019, 0x450000c0,
  0x00005100, 0x450000c0, 0x000051e6, 0x470000c0, 0x000052cc, 0x45000180, 0x00005499, 0x4a000180,
  0x00005666, 0x470000c0, 0x0000574c, 0x470000c0, 0x00005833, 0x47000180, 0x00005a00, 0x470000c0,
  0x00005ae6, 0x470000c0, 0x00005bcc, 0x47000180, 0x00005d99, 0x470000c0, 0x00005e80, 0x4a0000c0,
  0x00005f66, 0x43000120, 0x000060c0, 0x45000060, 0x00006133, 0x47000300, 0x000064cc, 0x480000c0,
  0x000065b3, 0x480000c0, 0x00006699, 0x48000120, 0x000067f3, 0x48000060, 0x00006866, 0x480000c0,
  0x0000694c, 0x470000c0, 0x00006a33, 0x470000c0, 0x00006b19, 0x47000060, 0x00006b8c, 0x47000060,
  0x00006c00, 0x4a0000c0, 0x00006ce6, 0x4a0000c0, 0x00006dcc, 0x480000c0, 0x00006eb3, 0x450000c0,
  0x00006f99, 0x430000c0, 0x00007080, 0x4a0000c0, 0x00007166, 0x4f0000c0, 0x00007333, 0x3e0000c0,
  0x00007419, 0x470000c0, 0x00007500, 0x450000c0, 0x000075e6, 0x430000c0, 0x000076cc, 0x3e000240,
  0x00007980, 0x3e000060, 0x000079f3, 0x3e000060, 0x00007a66, 0x3e0000c0, 0x00007b4c, 0x470000c0,
  0x00007c33, 0x450000c0, 0x00007d19, 0x430000c0, 0x00007e00, 0x40000300, 0x00008199, 0x400000c0,
  0x00008280, 0x480000c0, 0x00008366, 0x470000c0, 0x0000844c, 0x450000c0, 0x00008533, 0x42000300,
  0x000088cc, 0x4a0000c0, 0x000089b3, 0x4a0000c0, 0x00008a99, 0x480000c0, 0x00008b80, 0x450000c0,
  0x00008c66, 0x47000300, 0x00009000, 0x3e0000c0, 0x000090e6, 0x470000c0, 0x000091cc, 0x450000c0,
  0x000092b3, 0x430000c0, 0x00009399, 0x3e000300, 0x00009733, 0x3e0000c0, 0x00009819, 0x470000c0,
  0x00009900, 0x450000c0, 0x000099e6, 0x430000c0, 0x00009acc, 0x40000240, 0x00009d80, 0x400000c0,
  0x00009e66, 0x400000c0, 0x00009f4c, 0x480000c0, 0x0000a033, 0x470000c0, 0x0000a119, 0x450000c0,
  0x0000a200, 0x4a0000c0, 0x0000a2e6, 0x4a0000c0, 0x0000a3cc, 0x4a0000c0, 0x0000a4b3, 0x4a0000c0,
  0x0000a599, 0x4c0000c0, 0x0000a680, 0x4a0000c0, 0x0000a766, 0x480000c0, 0x0000a84c, 0x450000c0,
  0x0000a933, 0x43000240, 0x0000accc, 0x470000c0, 0x0000adb3, 0x470000c0, 0x0000ae99, 0x47000180,
  0x0000b066, 0x470000c0, 0x0000b14c, 0x470000c0, 0x0000b233, 0x47000180, 0x0000b400, 0x470000c0,
  0x0000b4e6, 0x4a0000c0, 0x0000b5cc, 0x43000120, 0x0000b726, 0x45000060, 0x0000b799, 0x47000300,
  0x0000bb33, 0x480000c0, 0x0000bc19, 0x480000c0, 0x0000bd00, 0x48000120, 0x0000be59, 0x48000060,
  0x0000becc, 0x480000c0, 0x0000bfb3, 0x470000c0, 0x0000c099, 0x470000c0, 0x0000c180, 0x47000060,
  0x0000c1f3, 0x47000060, 0x0000c266, 0x470000c0, 0x0000c34c, 0x450000c0, 0x0000c433, 0x450000c0,
  0x0000c519, 0x470000c0, 0x0000c600, 0x45000180, 0x0000c7cc, 0x4a000180, 0x0000c999, 0x470000c0,
  0x0000ca80, 0x470000c0, 0x0000cb66, 0x47000180, 0x0000cd33, 0x470000c0, 0x0000ce19, 0x470000c0,
  0x0000cf00, 0x47000180, 0x0000d0cc, 0x470000c0, 0x0000d1b3, 0x4a0000c0, 0x0000d299, 0x43000120,
  0x0000d3f3, 0x45000060, 0x0000d466, 0x47000300, 0x0000d800, 0x480000c0, 0x0000d8e6, 0x480000c0,
  0x0000d9cc, 0x48000120, 0x0000db26, 0x48000060, 0x0000db99, 0x480000c0, 0x0000dc80, 0x470000c0,
  0x0000dd66, 0x470000c0, 0x0000de4c, 0x47000060, 0x0000dec0, 0x47000060, 0x0000df33, 0x4a0000c0,
  0x0000e019, 0x4a0000c0, 0x0000e100, 0x480000c0, 0x0000e1e6, 0x450000c0, 0x0000e2cc, 0x430000c0,
  0x0000e3b3, 0x4a0000c0, 0x0000e499, 0x4f0000c0
};

const uint32_t PROGMEM sndWeWishYouAMerryXmasData[] = {
  0x00000092, // frame length = 146
  0x000001cc, 0x3f0000c0, 0x000002b3, 0x440000c0, 0x00000399, 0x44000060, 0x0000040c, 0x46000060,
  0x00000480, 0x44000060, 0x000004f3, 0x43000060, 0x00000566, 0x410000c0, 0x0000064c, 0x41000090,
  0x00000733, 0x410000c0, 0x00000819, 0x460000c0, 0x00000900, 0x46000060, 0x00000973, 0x48000060,
  0x000009e6, 0x46000060, 0x00000a59, 0x44000060, 0x00000acc, 0x430000c0, 0x00000bb3, 0x3f000090,
  0x00000c99, 0x3f0000c0, 0x00000d80, 0x480000c0, 0x00000e66, 0x48000060, 0x00000ed9, 0x49000060,
  0x00000f4c, 0x48000060, 0x00000fc0, 0x46000060, 0x00001033, 0x440000c0, 0x00001119, 0x41000090,
  0x00001200, 0x3f000060, 0x00001273, 0x3f000060, 0x000012e6, 0x41000090, 0x000013cc, 0x46000090,
  0x000014b3, 0x43000090, 0x00001599, 0x44000150, 0x00001766, 0x4b000060, 0x000017d9, 0x4d000030,
  0x00001813, 0x4f000030, 0x0000184c, 0x500000c0, 0x00001933, 0x50000060, 0x000019a6, 0x52000060,
  0x00001a19, 0x50000060, 0x00001a8c, 0x4f000060, 0x00001b00, 0x4d0000c0, 0x00001be6, 0x4d000090,
  0x00001ccc, 0x4d0000c0, 0x00001db3, 0x520000c0, 0x00001e99, 0x52000060, 0x00001f0c, 0x54000060,
  0x00001f80, 0x52000060, 0x00001ff3, 0x50000060, 0x00002066, 0x4f0000c0, 0x0000214c, 0x4b000090,
  0x00002233, 0x4b0000c0, 0x00002319, 0x540000c0, 0x00002400, 0x54000060, 0x00002473, 0x55000060,
  0x000024e6, 0x54000060, 0x00002559, 0x52000060, 0x000025cc, 0x500000c0, 0x000026b3, 0x4d000090,
  0x00002799, 0x4b000060, 0x0000280c, 0x4b000060, 0x00002880, 0x4d000090, 0x00002966, 0x52000090,
  0x00002a4c, 0x4f000090, 0x00002b33, 0x50000150, 0x00002d00, 0x3f0000c0, 0x00002de6, 0x440000c0,
  0x00002ecc, 0x440000c0, 0x00002fb3, 0x440000c0, 0x00003099, 0x43000180, 0x00003266, 0x430000c0,
  0x0000334c, 0x440000c0, 0x00003433, 0x430000c0, 0x00003519, 0x410000c0, 0x00003600, 0x3f000150,
  0x000037cc, 0x460000c0, 0x000038b3, 0x480000c0, 0x00003999, 0x460000c0, 0x00003a80, 0x440000c0,
  0x00003b66, 0x4b0000c0, 0x00003c4c, 0x3f0000c0, 0x00003d33, 0x3f000060, 0x00003da6, 0x3f000060,
  0x00003e19, 0x41000090, 0x00003f00, 0x46000090, 0x00003fe6, 0x43000090, 0x000040cc, 0x44000150,
  0x00004299, 0x3f0000c0, 0x00004380, 0x440000c0, 0x00004466, 0x44000060, 0x000044d9, 0x46000060,
  0x0000454c, 0x44000060, 0x000045c0, 0x43000060, 0x00004633, 0x410000c0, 0x00004719, 0x41000090,
  0x00004800, 0x410000c0, 0x000048e6, 0x460000c0, 0x000049cc, 0x46000060, 0x00004a40, 0x48000060,
  0x00004ab3, 0x46000060, 0x00004b26, 0x44000060, 0x00004b99, 0x430000c0, 0x00004c80, 0x3f000090,
  0x00004d66, 0x3f0000c0, 0x00004e4c, 0x480000c0, 0x00004f33, 0x48000060, 0x00004fa6, 0x49000060,
  0x00005019, 0x48000060, 0x0000508c, 0x46000060, 0x00005100, 0x440000c0, 0x000051e6, 0x41000090,
  0x000052cc, 0x3f000060, 0x00005340, 0x3f000060, 0x000053b3, 0x41000090, 0x00005499, 0x46000090,
  0x00005580, 0x43000090, 0x00005666, 0x44000150, 0x00005833, 0x4e000060, 0x000058a6, 0x50000030,
  0x000058e0, 0x52000030, 0x00005919, 0x530000c0, 0x00005a00, 0x53000060, 0x00005a73, 0x55000060,
  0x00005ae6, 0x53000060, 0x00005b59, 0x52000060, 0x00005bcc, 0x500000c0, 0x00005cb3, 0x50000090,
  0x00005d99, 0x500000c0, 0x00005e80, 0x550000c0, 0x00005f66, 0x55000060, 0x00005fd9, 0x57000060,
  0x0000604c, 0x55000060, 0x000060c0, 0x53000060, 0x00006133, 0x520000c0, 0x00006219, 0x4e000090,
  0x00006300, 0x4e0000c0, 0x000063e6, 0x570000c0, 0x000064cc, 0x57000060, 0x00006540, 0x58000060,
  0x000065b3, 0x57000060, 0x00006626, 0x55000060, 0x00006699, 0x530000c0, 0x00006780, 0x50000090,
  0x00006866, 0x4e000060, 0x000068d9, 0x4e000060, 0x0000694c, 0x50000090, 0x00006a33, 0x55000090,
  0x00006b19, 0x52000090, 0x00006c00, 0x53000150
};

const uint32_t* melodies[MELODIES_MAX] = {
  sndCanonInDData,
  sndJingleBellsData,
  sndWeWishYouAMerryXmasData
};

void setMelody(const uint32_t* melody) {
  melodyActive = melody + 1;
  melodyLength = pgm_read_word(melody);
  melodyIndex = 0;
  melodyTimeRef = millis();
}

bool selectMelody(uint8_t index, int16_t loops) {
  if (index >= MELODIES_MAX) {
    return false;
  }

  setMelody(melodies[index]);
  melodyLoop = loops;

  return true;
}
